from inc_noesis import *

def registerNoesisTypes():
    handle = noesis.register("test for moonpaladin", ".example")
    noesis.setHandlerTypeCheck(handle, noepyCheckType)
    noesis.setHandlerLoadModel(handle, noepyLoadModel)
    noesis.setHandlerWriteModel(handle, noepyWriteModel)
    noesis.logPopup()
    return 1
       
def noepyCheckType(data):
    bs = NoeBitStream(data)
    if noeAsciiFromBytes(bs.readBytes(7)) != 'EXAMPLE':
        return 0
    return 1

def noepyLoadModel(data, mdlList):
    bs = NoeBitStream(data)
    bs.seek(11)
    
    ctx = rapi.rpgCreateContext()
    #0-indices; 1-vert; 2-norm; 3-uvs;
    info = [bs.readUInt() for x in range(4)]

    faces = bs.readBytes(info[0] * 2)
    
    stride = 0
    if info[1]: stride+=12
    if info[2]: stride+=12
    if info[3]: stride+=8
    
    data = bs.readBytes(info[1] * stride)
    
    rapi.rpgSetName("Mesh_0")
    rapi.rpgBindPositionBufferOfs(data, noesis.RPGEODATA_FLOAT, stride, 0)
    if info[2]>0:
        rapi.rpgBindNormalBufferOfs(data, noesis.RPGEODATA_FLOAT, stride, 12)
    if info[3]>0:
        rapi.rpgBindUV1BufferOfs(data, noesis.RPGEODATA_FLOAT, stride, stride-8)
    rapi.rpgCommitTriangles(faces, noesis.RPGEODATA_USHORT, info[0], noesis.RPGEO_TRIANGLE)

    mdl = rapi.rpgConstructModel()
    
    mdlList.append(mdl)
    return 1
    
def noepyWriteModel(mdl, bs):
    mesh = mdl.meshes[0]
    magic = "EXAMPLE"
    ver = 1
    
    indices = mesh.indices
    vertex = mesh.positions
    normals = mesh.normals
    uvs = mesh.uvs
    
    bs.writeString(magic, 0)
    bs.writeInt(ver)
    
    bs.writeInt(len(indices))
    bs.writeInt(len(vertex))
    bs.writeInt(len(normals))
    bs.writeInt(len(uvs))
    
    for x in indices:
        bs.writeUShort(x)

    for x in range(len(vertex)):
        [bs.writeFloat(y) for y in vertex[x]]
        if normals:
            [bs.writeFloat(y) for y in normals[x]]
        if uvs:
            [bs.writeFloat(y) for y in uvs[x][:2]]
    return 1
